#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/checkbox.h>
#include <wx/tglbtn.h>
#include <wx/choice.h>
#include <wx/button.h>
#include <wx/frame.h>
#include <wx/timer.h>


#include "port.h"

class MiFrame: public wxFrame
{
public:
    MiFrame(wxWindow* parent,wxWindowID id = -1);
	virtual ~MiFrame();
	
	void Repintado(wxClientDC * dc1);
	wxClientDC * dcPantalla;
	wxMemoryDC * dcBuffer;
	wxBitmap *m_bitmap;
	
private:	
    DECLARE_EVENT_TABLE()

		void OnAbout(wxCommandEvent& event)
		{
                wxString msg;
				msg.Printf(wxT("wxSerialPloter\nxsetaseta@gmail.com\n%s"),    wxVERSION_STRING);
				wxMessageBox(msg, wxT("SETA43"), wxOK | wxICON_INFORMATION, this);
         }   
		void OnClose(wxCloseEvent& event);
        void OnBdeviceSelected(wxCommandEvent& event);
        void OnBpauseClick(wxCommandEvent& event);
        void OnBclearClick(wxCommandEvent& event);
        void OnBcodigoClick(wxCommandEvent& event);
        void MiTimer(wxTimerEvent& event);
        void OnPaint(wxPaintEvent& event);
        void OnBmodeClick(wxCommandEvent& event);
                       
		wxButton* Bclear;
        wxCheckBox* Bpause;
        wxCheckBox*  Bmode; 
        wxStaticText* StaticText1;
        wxButton* Bcodigo;
        wxTextCtrl* Bconsola;
        wxComboBox* Bdevice;                 
};

class MiAplicacion : public wxApp
{
public:
    virtual bool OnInit();
};


bool MiAplicacion::OnInit()
{
	wxInitAllImageHandlers();
    MiFrame* Frame = new MiFrame(0);
    
    Frame->Show();
    
    return true;
}

