/***************************************************************
 * Name:      wxSerieMain.h
 * Purpose:   Defines Application Frame
 * Author:    seta43 ()
 * Created:   2018-05-14
 * Copyright: seta43 ()
 * License:
 **************************************************************/

#include "main.h"
#include "define.h"
#include "port.h"


char VARI[100];
int  ContadorI=0;
char Binput[100];
char Binput2[20];
int tiempo2=10,tiempo1=5;

int canal1,canal2;
int ejex;

unsigned char portok;
bool Spause;


#define ID_CODIGO	1000
#define ID_CLEAR	1001
#define  ID_DEVICE	1002
#define  ID_CONSOLA		1003
#define ID_BUTTON1	1004
#define ID_BUTTON2	1005
#define ID_STATICTEXT1		1006
#define ID_PAUSE	1007

DECLARE_APP(MiAplicacion)
// Give wxWidgets the means to create a MiAplicacion object
IMPLEMENT_APP(MiAplicacion)

BEGIN_EVENT_TABLE(MiFrame,wxFrame)

    EVT_BUTTON(ID_CODIGO, MiFrame::OnBcodigoClick)
    EVT_BUTTON(ID_CLEAR, MiFrame::OnBclearClick)
    EVT_TIMER(1000, MiFrame::MiTimer)
    EVT_PAINT(MiFrame::OnPaint)
    EVT_COMBOBOX(ID_DEVICE,MiFrame::OnBdeviceSelected)
    EVT_CHECKBOX(ID_PAUSE,MiFrame::OnBpauseClick)

END_EVENT_TABLE();




MiFrame::MiFrame(wxWindow* parent,wxWindowID id)
{
	Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    SetClientSize(wxSize(810,352));
    SetMinSize(wxSize(810,352));
    SetMaxSize(wxSize(810,352));
    Bdevice = new wxComboBox(this, ID_DEVICE, wxEmptyString, wxPoint(8,312), wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_DEVICE"));
    Bdevice->SetSelection( Bdevice->Append(_("Selec Device")) );
    Bdevice->Append(_("/dev/ttyUSB0"));
    Bdevice->Append(_("/dev/ttyUSB1"));
    Bdevice->Append(_("/dev/ttyUSB2"));
    Bdevice->Append(_("/dev/ttyACM0"));
    Bdevice->Append(_("/dev/ttyACM1"));
    Bdevice->Append(_("/dev/ttyACM2"));
    Bdevice->Append(_("/dev/ttyS0"));
    Bdevice->Append(_("/dev/ttyS1"));
    Bdevice->Append(_("/dev/ttyS2"));
    Bconsola = new wxTextCtrl(this, ID_CONSOLA, _("Text"), wxPoint(144,312), wxSize(152,22), 0, wxDefaultValidator, _T("ID_CONSOLA"));
    wxFont BconsolaFont(7,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Bconsola->SetFont(BconsolaFont);
    Bpause = new wxCheckBox(this, ID_PAUSE, _("Pause"), wxPoint(336,312), wxSize(72,21), 0, wxDefaultValidator, _T("ID_PAUSE"));
    Bpause->SetValue(false);
    Bclear = new wxButton(this, ID_CLEAR, _("Clear"), wxPoint(440,304), wxSize(61,27), 0, wxDefaultValidator, _T("ID_CLEAR"));
    Bcodigo = new wxButton(this, ID_CODIGO, _("Code"), wxPoint(528,304), wxSize(61,27), 0, wxDefaultValidator, _T("ID_CODE"));
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("http://seta43.hol.es/electro.html\nhttp://seta43.blogspot.com.es/"), wxPoint(608,304), wxSize(195,22), 0, _T("ID_STATICTEXT1"));
    wxFont StaticText1Font(8,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText1->SetFont(StaticText1Font);

   
    wxTimer *MiTimer= new wxTimer();
    MiTimer->SetOwner(this, 1000);
    MiTimer->Start(20);	// 50 veces por Segundo
    m_bitmap = new wxBitmap(800, 270, 32);
    
   wxMemoryDC dcBuffer(*m_bitmap);
	wxClientDC dcPantalla(this );			
			dcBuffer.Clear();	

			dcBuffer.SetPen(wxPen(wxColor(0,0,0), 1, wxSOLID));	
			dcBuffer.DrawLine(0,260,800,260);
			dcBuffer.DrawLine(30,0,30,270);			
			dcBuffer.DrawLine(30,4,800,4);
			
			dcBuffer.DrawLine(20,65,30,65);
			dcBuffer.DrawLine(20,130,30,130);
			dcBuffer.DrawLine(20,195,30,195);
			
			wxFont  LabelFont     = wxFont( 9, wxSWISS, wxFONTSTYLE_NORMAL, wxNORMAL, false, _("Courier") );
			dcBuffer.SetFont( LabelFont );
			dcBuffer.DrawText(wxT("1024"), 0, 0); 
			dcBuffer.DrawText(wxT("0"), 0, 246);			
	dcPantalla.Blit(0,0,800,270, &dcBuffer, 0, 0, wxCOPY, true);
	
	ejex=31;
	Spause=0;
}

void Repintar(void)
{
	

}

void MiFrame::OnBdeviceSelected(wxCommandEvent& event)
{
	 wxString msg,string1;
#if DEBUG     
    if(DEBUG) printf("Init\n");
#endif
#if YesWindows
	MiBAUDIOS=CBR_115200;
    if(hSerial)CloseRs232();
#else
	MiBAUDIOS=B115200;
    if(fdrs232)CloseRs232();    
#endif

    msg=Bdevice->GetStringSelection();
    strcpy( VARI, (const char*)msg.mb_str(wxConvUTF8) );
    MODEMDEVICE=VARI;

    if(0!=IniRs232())
    {
        printf("NO %s\n",MODEMDEVICE);
        msg.Printf(wxT("No existe puerto"));
        wxMessageBox(msg, wxT("ERROR"), wxOK | wxICON_INFORMATION, this);
        msg.Printf(wxT("No port"));
        Bconsola->SetValue(msg);
        portok=0;
    }
    else
    {
        wxString string1(VARI, wxConvUTF8);
        Bconsola->SetValue(msg+_(" :115200,8,N,1"));      
		printf("SI %s\n",MODEMDEVICE);		    
        portok=1;
    }
	
}

void MiFrame::OnBpauseClick(wxCommandEvent& event)
{
	if(Bpause->GetValue())
		Spause=1;
	 else 
		Spause=0;
	printf("Boton PAUSE __%d\n",Spause);
}

void MiFrame::OnBclearClick(wxCommandEvent& event)
{
	printf("Boton CLEAR \n");
	ejex=31;

	wxMemoryDC dcBuffer(*m_bitmap);
	wxClientDC dcPantalla(this );			
			dcBuffer.Clear();	

			dcBuffer.SetPen(wxPen(wxColor(0,0,0), 1, wxSOLID));	
			dcBuffer.DrawLine(0,260,800,260);
			dcBuffer.DrawLine(30,0,30,270);			
			dcBuffer.DrawLine(30,4,800,4);
			
			dcBuffer.DrawLine(20,65,30,65);
			dcBuffer.DrawLine(20,130,30,130);
			dcBuffer.DrawLine(20,195,30,195);
			
			wxFont  LabelFont     = wxFont( 9, wxSWISS, wxFONTSTYLE_NORMAL, wxNORMAL, false, _("Courier") );
			dcBuffer.SetFont( LabelFont );
			dcBuffer.DrawText(wxT("1024"), 0, 0); 
			dcBuffer.DrawText(wxT("0"), 0, 246);
			 	 
			// Directo a pantalla				 	 
			//dcPantalla.SetBrush(*wxGREEN_BRUSH); // green filling
			//dcPantalla.SetPen( wxPen( wxColor(255,0,0), 5 ) ); // 5-pixels-thick red outline
			//dcPantalla.DrawCircle( wxPoint(200,270), 25 /* radius */ );		 	 			
			//______________________	 	 
	dcPantalla.Blit(0,0,800,270, &dcBuffer, 0, 0, wxCOPY, true);
}

void MiFrame::OnBcodigoClick(wxCommandEvent& event)
{
	wxString msg;
		msg.Printf(wxT("\n//http://seta43.hol.es/electro.html\n//Para utilizar con IDEploter arduino 1.6\n\n#define ANA0  A0\n#define ANA1  A1\n\nvoid setup()\n{\n  Serial.begin(115200);\n  pinMode(ANA0, INPUT);\n  pinMode(ANA1, INPUT);    \n}\n\nvoid loop()\n{\n  Serial.print(analogRead(ANA0));\n  Serial.print(\",\");\n  Serial.println(analogRead(ANA1)); \n  delay(25);\n}"),    wxVERSION_STRING);
		wxMessageBox(msg, wxT("SETA43"), wxOK | wxICON_INFORMATION, this);
}

void MiFrame::MiTimer(wxTimerEvent& event)
{
    int z;
    int nbytes;
   
    tiempo2--;
 
#if DEBUG  
	tiempo1--;
	if(tiempo1<0)
		{
		 tiempo1=20;
		 printf("1Segundo\n");
		}
#endif		
    
// ____________________________________
    if(portok==1 && tiempo2<0)
    {
        tiempo2=2;

#if YesWindows
        while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else
        while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif
        {
            //printf("Leer %d -> %s\n",ContadorI,Binput2);
            Binput[ContadorI]=Binput2[0];
            ContadorI++;
            if (Binput2[0] == '\n')
            {
                if(ContadorI<2)ContadorI=2;
                Binput[ContadorI-2]=0;
                ContadorI=0;
#if DEBUG
				printf("Leidos->%s\n",Binput);
#endif
                sprintf(VARI,"%s\n",Binput);
                //printf("%s",VARI);
                for(z=0; z<99; z++) if(VARI[z]==',')  {VARI[z]=0; z++; break;}
                canal1=atoi(VARI);	canal1>>=2;
                canal2=atoi(VARI+z); canal2>>=2;              
         //       printf("d1=%d   D2=%d \n",canal1,canal2);
                if(!Spause) 
                {            
                 wxPaintDC dcPantalla(this);
				 wxMemoryDC dcBuffer(*m_bitmap);
					dcBuffer.SetPen(wxPen(wxColor(255,255,255), 1, wxSOLID));
					dcBuffer.DrawLine(ejex,5,ejex,259);
					dcBuffer.SetPen(wxPen(wxColor(255,0,0), 1, wxSOLID));	
					dcBuffer.DrawPoint(ejex,259-canal1); 
					dcBuffer.SetPen(wxPen(wxColor(0,0,255), 1, wxSOLID));
					dcBuffer.DrawPoint(ejex,259-canal2); 	
                 dcPantalla.Blit(0,0,800,270, &dcBuffer, 0, 0, wxCOPY, true);                
                 ejex++;
				}
				if(ejex>800)ejex=31;
            }
        }
    }
}

void MiFrame::OnPaint(wxPaintEvent& event)
{
	printf("d-repintar Onpaint \n");
	wxPaintDC dcPantalla(this);
	wxMemoryDC dcBuffer(*m_bitmap);
	dcPantalla.Blit(0,0,800,270, &dcBuffer, 0, 0, wxCOPY, true);	
}
